%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

%define oname ppx_deriving

Name:           ocaml-%{oname}
Version:        6.0.3
Release:        %mkrel 1
Summary:        Type-driven code generation for OCaml
License:        MIT
Group:          Development/OCaml
URL:            https://ocaml-ppx.github.io/ppx_deriving/
VCS:            git:%{giturl}.git
Source:         %{giturl}/archive/v%{version}//%{oname}-%{version}.tar.gz

BuildRequires:  ocaml >= 4.05.0
BuildRequires:  ocaml-cppo >= 1.1.0
BuildRequires:  ocaml-dune >= 1.6.3
BuildRequires:  ocaml-findlib-devel
BuildRequires:  ocaml-ounit-devel
BuildRequires:  ocaml-ppx_derivers-devel
BuildRequires:  ocaml-ppxlib-devel >= 0.32.0

%description
Deriving is a library simplifying type-driven code generation on OCaml.
It includes a set of useful plugins: show, eq, ord (eq), enum, iter,
map (iter), fold (iter), make, yojson, and protobuf.

%package        devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name} = %{version}-%{release}
Requires:       ocaml-ppx_derivers-devel%{?_isa}
Requires:       ocaml-ppxlib-devel%{?_isa}

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%autosetup -n %{oname}-%{version} -p1

%build
%dune_build

%install
%dune_install

# Help the debuginfo generator find the source files
cd _build/default
ln -s ../../src/ppx_deriving_main.cppo.ml
ln -s ../../src/api/ppx_deriving.cppo.ml .
ln -s ../../src/runtime/ppx_deriving_runtime.cppo.ml .
ln -s ../../src_plugins/create/ppx_deriving_create.cppo.ml .
ln -s ../../src_plugins/enum/ppx_deriving_enum.cppo.ml .
ln -s ../../src_plugins/eq/ppx_deriving_eq.cppo.ml .
ln -s ../../src_plugins/fold/ppx_deriving_fold.cppo.ml .
ln -s ../../src_plugins/iter/ppx_deriving_iter.cppo.ml .
ln -s ../../src_plugins/make/ppx_deriving_make.cppo.ml .
ln -s ../../src_plugins/map/ppx_deriving_map.cppo.ml .
ln -s ../../src_plugins/ord/ppx_deriving_ord.cppo.ml
ln -s ../../src_plugins/show/ppx_deriving_show.cppo.ml
cd -

%check
%dune_check

%files -f .ofiles
%doc CHANGELOG.md README.md
%license LICENSE.txt

%files devel -f .ofiles-devel


%changelog
* Thu Jun 19 2025 daviddavid <daviddavid> 6.0.3-1.mga10
+ Revision: 2192930
- new version: 6.0.3
+ tv <tv>
- rebuild for new ocaml

* Thu Feb 18 2016 pterjan <pterjan> 3.1-1.mga6
+ Revision: 965199
- Fix file list
- Move executable to a better place
- imported package ocaml-ppx_deriving

